package samples;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;
import java.util.Arrays;
import java.util.Map;

/**
 * Java application testing "generics"
 *
 * @version 1.01 02/02/2005
 * @author  John Jay King
 *
 * Will not compile in Java 1.4 or earlier
 */
public class UsingGenerics {

	public static void main(String[] args) {
		int[] myarray = { 1, 2, 3, 4 };
		System.out.println("myarray=" + Arrays.toString(myarray));
		ArrayList oldStyle = new ArrayList();
		oldStyle.add(new String("Hello"));
		oldStyle.add(new String("there"));
		// oldStyle.add(new Integer(12)); // ok the old way
		oldStyle.add(new String("whoops"));
		// following loop raise runtime error
		for (Iterator i = oldStyle.iterator(); i.hasNext();) {
			System.out.println("Entry = " + (String) i.next());
		}
		ArrayList<String> newStyle = new ArrayList<String>();
		newStyle.add(new String("Hello"));
		newStyle.add(new String("there"));
		// following line raises compile error
		// newStyle.add(new Integer(12));
		newStyle.add(new String("whoops"));
		for (Iterator<String> i = newStyle.iterator(); i.hasNext();) {
			System.out.println("Entry = " + (String) i.next());
		}
		HashMap<Integer, Integer> cubes = new HashMap<Integer, Integer>();
		for (int i = 0; i < 10; i++) {
			cubes.put(i, i * i * i);
		}
		for (int i = 0; i < 10; i++) {
			System.out.println("Cube of " + i + " = " + cubes.get(i));
		}
		printArrayList(newStyle);

	} // end main

	static void printArrayList(ArrayList<String> inList) {
		for (Iterator<String> i = inList.iterator(); i.hasNext();) {
			System.out.println("Entry = " + (String) i.next());
		}

	}
} // end UsingGenerics
